/*
 * Petalus a crypto micro service wallet database.
 *
 * Copyright (C) 2018-2021  Luis Campo Giralte
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 * Written by Luis Campo Giralte <luis.camp0.2009@gmail.com>
 *
 */

#ifndef SRC_TCPCONNECTIONTABLE_H_
#define SRC_TCPCONNECTIONTABLE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <unordered_map>
#include <memory>
#include "Pointer.h"

namespace petalus {

template <typename T>
struct Connection {
public:
        Connection() {}

	WeakPointer<T> conn;
        std::string ip = "";
};

// TCP connection tables for tracking
template <typename T>
using TCPTable = std::unordered_map<std::string, SharedPointer<Connection<T>>>;


} // namespace petalus

#endif  // SRC_TCPCONNECTIONTABLE_H_
